# GoogleEarthEnterpriseImageryProvider

#### new Cesium.GoogleEarthEnterpriseImageryProvider(options)
engine/Source/Scene/GoogleEarthEnterpriseImageryProvider.js 88

To construct a GoogleEarthEnterpriseImageryProvider, call `GoogleEarthEnterpriseImageryProvider.fromMetadata`. Do not call the constructor directly.
Provides tiled imagery using the Google Earth Enterprise REST API. Notes: This provider is for use with the 3D Earth API of Google Earth Enterprise, `GoogleEarthEnterpriseMapsProvider` should be used with 2D Maps API.

Name | Type | Description
--- | --- | ---
`options` | GoogleEarthEnterpriseImageryProvider.ConstructorOptions | optional Object describing initialization options

##### Example:

    const geeMetadata = await GoogleEarthEnterpriseMetadata.fromUrl("http://www.example.com");
    const gee = Cesium.GoogleEarthEnterpriseImageryProvider.fromMetadata(geeMetadata);

##### See:

- GoogleEarthEnterpriseImageryProvider.fromMetadata
- GoogleEarthEnterpriseTerrainProvider
- ArcGisMapServerImageryProvider
- GoogleEarthEnterpriseMapsProvider
- OpenStreetMapImageryProvider
- SingleTileImageryProvider
- TileMapServiceImageryProvider
- WebMapServiceImageryProvider
- WebMapTileServiceImageryProvider
- UrlTemplateImageryProvider
- Cross-Origin Resource Sharing

### Members

#### readonly credit : Credit
engine/Source/Scene/GoogleEarthEnterpriseImageryProvider.js 265

Gets the credit to display when this imagery provider is active. Typically this is used to credit the source of the imagery.

#### readonly errorEvent : Event
engine/Source/Scene/GoogleEarthEnterpriseImageryProvider.js 252

Gets an event that is raised when the imagery provider encounters an asynchronous error. By subscribing to the event, you will be notified of the error and can potentially recover from it. Event listeners are passed an instance of `TileProviderError`.

#### readonly hasAlphaChannel : boolean
engine/Source/Scene/GoogleEarthEnterpriseImageryProvider.js 281

Gets a value indicating whether or not the images provided by this imagery provider include an alpha channel. If this property is false, an alpha channel, if present, will be ignored. If this property is true, any images without an alpha channel will be treated as if their alpha is 1.0 everywhere. Setting this property to false reduces memory usage and texture upload time.

#### readonly maximumLevel : number|undefined
engine/Source/Scene/GoogleEarthEnterpriseImageryProvider.js 188

Gets the maximum level-of-detail that can be requested.

#### readonly minimumLevel : number
engine/Source/Scene/GoogleEarthEnterpriseImageryProvider.js 200

Gets the minimum level-of-detail that can be requested.

#### readonly proxy : Proxy
engine/Source/Scene/GoogleEarthEnterpriseImageryProvider.js 152

Gets the proxy used by this provider.

#### readonly rectangle : Rectangle
engine/Source/Scene/GoogleEarthEnterpriseImageryProvider.js 224

Gets the rectangle, in radians, of the imagery provided by this instance.

#### readonly tileDiscardPolicy : TileDiscardPolicy
engine/Source/Scene/GoogleEarthEnterpriseImageryProvider.js 238

Gets the tile discard policy. If not undefined, the discard policy is responsible for filtering out "missing" tiles via its shouldDiscardImage function. If this function returns undefined, no tiles are filtered.

#### readonly tileHeight : number
engine/Source/Scene/GoogleEarthEnterpriseImageryProvider.js 176

Gets the height of each tile, in pixels.

#### readonly tileWidth : number
engine/Source/Scene/GoogleEarthEnterpriseImageryProvider.js 164

Gets the width of each tile, in pixels.

#### readonly tilingScheme : TilingScheme
engine/Source/Scene/GoogleEarthEnterpriseImageryProvider.js 212

Gets the tiling scheme used by this provider.

#### readonly url : string
engine/Source/Scene/GoogleEarthEnterpriseImageryProvider.js 140

Gets the name of the Google Earth Enterprise server url hosting the imagery.

### Methods

#### static Cesium.GoogleEarthEnterpriseImageryProvider.fromMetadata(metadata, options) → GoogleEarthEnterpriseImageryProvider
engine/Source/Scene/GoogleEarthEnterpriseImageryProvider.js 300

Creates a tiled imagery provider using the Google Earth Enterprise REST API.

Name | Type | Description
--- | --- | ---
`metadata` | GoogleEarthEnterpriseMetadata | A metadata object that can be used to share metadata requests with a GoogleEarthEnterpriseTerrainProvider.
`options` | GoogleEarthEnterpriseImageryProvider.ConstructorOptions | Object describing initialization options.

##### Returns:

##### Throws:

- RuntimeError : The metadata url does not have imagery

##### Example:

    const geeMetadata = await GoogleEarthEnterpriseMetadata.fromUrl("http://www.example.com");
    const gee = Cesium.GoogleEarthEnterpriseImageryProvider.fromMetadata(geeMetadata);

#### getTileCredits(x, y, level) → Array.<Credit>
engine/Source/Scene/GoogleEarthEnterpriseImageryProvider.js 325

Gets the credits to be displayed when a given tile is displayed.

Name | Type | Description
--- | --- | ---
`x` | number | The tile X coordinate.
`y` | number | The tile Y coordinate.
`level` | number | The tile level;

##### Returns:

The credits to be displayed when the tile is displayed.

#### pickFeatures(x, y, level, longitude, latitude) → undefined
engine/Source/Scene/GoogleEarthEnterpriseImageryProvider.js 431

Picking features is not currently supported by this imagery provider, so this function simply returns undefined.

Name | Type | Description
--- | --- | ---
`x` | number | The tile X coordinate.
`y` | number | The tile Y coordinate.
`level` | number | The tile level.
`longitude` | number | The longitude at which to pick features.
`latitude` | number | The latitude at which to pick features.

##### Returns:

Undefined since picking is not supported.

#### requestImage(x, y, level, request) → Promise.<ImageryTypes>|undefined
engine/Source/Scene/GoogleEarthEnterpriseImageryProvider.js 352

Requests the image for a given tile.

Name | Type | Description
--- | --- | ---
`x` | number | The tile X coordinate.
`y` | number | The tile Y coordinate.
`level` | number | The tile level.
`request` | Request | optional The request object. Intended for internal use only.

##### Returns:

A promise for the image that will resolve when the image is available, or undefined if there are too many active requests to the server, and the request should be retried later.

### Type Definitions

#### Cesium.GoogleEarthEnterpriseImageryProvider.ConstructorOptions
engine/Source/Scene/GoogleEarthEnterpriseImageryProvider.js 43

Initialization options for the GoogleEarthEnterpriseImageryProvider constructor

##### Properties:

Name | Type | Attributes | Description
--- | --- | --- | ---
`ellipsoid` | Ellipsoid | <optional> | The ellipsoid. If not specified, the WGS84 ellipsoid is used.
`tileDiscardPolicy` | TileDiscardPolicy | <optional> | The policy that determines if a tile is invalid and should be discarded. If this value is not specified, a default is to discard tiles that fail to download.
`credit` | Credit | string | <optional> | A credit for the data source, which is displayed on the canvas.

Need help? The fastest way to get answers is from the community and team on the Cesium Forum.